(function ($)
{
    Drupal.behaviors.openlayersInput = 
    {
        attach: function (context, settings) 
        {
            var raster = new ol.layer.Tile({
                source: new ol.source.OSM()
            });
            
            var vectorSource = new ol.source.Vector({wrapX: false});
            var vector = new ol.layer.Vector({
                source: vectorSource
            });
            
            var map = new ol.Map({
                layers: [raster,vector],
                target: settings.openlayers.mapid,
                view: new ol.View({
                    center: [0, 0],
                    zoom: 2,
                    extent: ol.proj.transform([-180.0000, -90.0000, 180.0000, 90.0000], 'EPSG:4326', 'EPSG:3857'),
                })
            });
            var format = new ol.format.WKT();
            
            var wkt = $('#openlayers-geomaswkt').val();
            console.log(wkt);
            var type = $('#openlayers-geomaswkt').val().toString();
            type = type.replace(/[ (),-.0-9]/g,"");
            if (type === "LINESTRING") {
                $('#openlayers-selectgeom').val('LineString');
            }
            if (type === "POLYGON") {
                $('#openlayers-selectgeom').val('Polygon');
            }
            if (type === "POINT") {
                $('#openlayers-selectgeom').val('Point');
            }
            if (wkt !== '') {
              var feature = format.readFeature(wkt, {
                dataProjection: 'EPSG:4326',
                featureProjection: 'EPSG:3857'
              });
              vectorSource.addFeature(feature);
            }
            
            var typeSelect = document.getElementById('openlayers-selectgeom');
            
            var draw; // global so we can remove it later
            function addInteraction() {
                var value = typeSelect.value;
                if (value !== 'None') {
                    draw = new ol.interaction.Draw({
                        source: vectorSource,
                        type: /** @type {ol.geom.GeometryType} */ (typeSelect.value)
                    });
                    map.addInteraction(draw);
                };
                draw.on('drawend', function(evt){
                    var feature = evt.feature;
                    var p = feature.getGeometry();
                    $('#openlayers-geomaswkt').val(format.writeFeature(feature, 
                    {
                       dataProjection: 'EPSG:4326',
                       featureProjection: 'EPSG:3857'
                    }));
                });
                
                draw.on('drawstart', function(evt){
                    $('#openlayers-geomaswkt').val('');
                    vectorSource.clear();
                });
            };
            addInteraction();
             
            typeSelect.onchange = function() {
                $('#openlayers-geomaswkt').val('');
                vectorSource.clear();
                map.removeInteraction(draw);
                addInteraction();
            }   
        }
    };
})(jQuery);