<?php
/**
 * @file
 * Contains \Drupal\openlayers\Form\MapForm.
 */

namespace Drupal\openlayers\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the content_entity_example entity edit forms.
 *
 * @ingroup content_entity_example
 */
class MapForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    /* @var $entity \Drupal\openlayers\Entity\OpenLayersMap */
    $tmp = parent::buildForm($form, $form_state);
    
    $form['advanced'] = array(
      '#type' => 'vertical_tabs',
      '#title' => t('Create Map'),
    );
    
    $form['base'] = array(
      '#type' => 'details',
      '#title' => t('Base'),
      '#group' => 'advanced',
    );
    
    $form['base']['map_name'] = $tmp['map_name'];
    $form['base']['map_height'] = $tmp['map_height'];
    $form['base']['zoom'] = $tmp['zoom'];
    $form['base']['minzoom'] = $tmp['minzoom'];
    $form['base']['maxzoom'] = $tmp['maxzoom'];
    
    $form['layer'] = array(
      '#type' => 'details',
      '#title' => t('Layers'),
      '#group' => 'advanced',
    );
    $form['layer']['layer_ref_base'] = $tmp['layer_ref_base'];
    $form['layer']['layer_ref_overlay'] = $tmp['layer_ref_overlay'];
    
    $form['control'] = array(
      '#type' => 'details',
      '#title' => t('Controls'),
      '#group' => 'advanced',
    );
    $form['control']['control_ref'] = $tmp['control_ref'];
    
    $form['actions'] = $tmp['actions'];
    
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    // Redirect to term list after save.
    $form_state->setRedirect('entity.openlayers.map.collection');
    $entity = $this->getEntity();
    $entity->save();
  }
}
